var StatusImages = new Array();
StatusImages["NLN"] = "chrome://msnmsgr/skin/status/online.png";
StatusImages["AWY"] = "chrome://msnmsgr/skin/status/away.png";
StatusImages["BRB"] = "chrome://msnmsgr/skin/status/away.png";
StatusImages["BSY"] = "chrome://msnmsgr/skin/status/busy.png";
StatusImages["PHN"] = "chrome://msnmsgr/skin/status/busy.png";
StatusImages["LUN"] = "chrome://msnmsgr/skin/status/busy.png";
StatusImages["IDL"] = "chrome://msnmsgr/skin/status/idle.png";
StatusImages["HDN"] = "chrome://msnmsgr/skin/status/offline.png";
StatusImages["FLN"] = "chrome://msnmsgr/skin/status/offline.png";
StatusImages["BLK"] = "chrome://msnmsgr/skin/status/blocked.png";
var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
                      .getService(Components.interfaces.nsIAlertsService);

function onMainLoad() {
  window.client = new MSNObject();
  document.getElementById("email").focus();
}

function onMainUnload() {
  window.client.closeSessions();
  if (window.client.isConnected == true) {
    window.client.logout();
  }
  delete window.client;
}

function changeNickname(nickname) {
  var currentNickname = document.getElementById("nickname").value;
  if (nickname.replace(/^\s+|\s+$/, "") != "" && nickname != currentNickname) {
    window.client.changeNickname(nickname);
    document.getElementById("nickname-deck").selectedIndex = "0";
  }
}

function changeStatus(status) {
  window.client.changeStatus(status);
}

function confirmContactAdd() {
  openWindowOnce("chrome://msnmsgr/contact/addcontact.xul", "msnsmgr:add-contact", "chrome");
}

function confirmContactDelete() {
  var tree = document.getElementById("contact-list-tree");
  var contactNode = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  if (confirm(window.client.bundle.GetStringFromName("contactDelete") + " " + contactNode.getAttribute("label") + " (" + contactNode.id + ")" + " ?")) {
    window.client.removeContact(contactNode.id, "FL");
  }
}

function contactlistDblClick(tree, event) {
  if (event.button == 0) {
    var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
    if (item.id == "emailItem") {
      window.client.requestEmailURL("INBOX");
    }
    else if (item.id != "online" && item.id != "offline") {
      setupSession();
    }
  }
}

function editNickname() {
  document.getElementById("nickname-deck").selectedIndex="1";
  document.getElementById("nickname-textbox").focus();
}

function sendEmail() {
  var tree = document.getElementById("contact-list-tree");
  var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  if (item.id != "emailItem" && item.id != "online" && item.id != "offline") {
    window.client.requestEmailURL(item.id);
  }
}

function sendIM() {
  var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  if (item.id != "emailItem" && item.id != "online" && item.id != "offline") {
    setupSession();
  }
}

function signIn() {
  var email = document.getElementById("email");
  var status = document.getElementById("initial-status").value;
  var re = /^.*\@.*\..*$/i; // valid e-mail in RegExp format
  var valid = re.exec(email.value); // check if the e-mail address is valid
  if (!valid) {
    alert(window.client.bundle.GetStringFromName("invalidEMail"));
  }
  else {
    document.getElementById("signin-button").disabled = true;
    document.getElementById(status + "_menuitem").checked = true;
    document.getElementById("main-pages").selectedIndex = 1;
    window.client.logon(email.value, document.getElementById("password").value, status);
  }
}

function signOut() {
  document.getElementById("signin-button").disabled = false;
  document.getElementById("signin-progress").value = 0;
  document.getElementById("sign-in-status").label = '';
  document.getElementById("main-pages").selectedIndex = 0;
  var onlist = document.getElementById("online-contacts-list");
  while (onlist.firstChild) {
    onlist.removeChild(onlist.firstChild);
  }
  var offlist = document.getElementById("offline-contacts-list");
  while (offlist.firstChild) {
    offlist.removeChild(offlist.firstChild);
  }
  window.client.logout();
  window.client = new MSNObject();
}

function toggleBlock() {
  var tree = document.getElementById("contact-list-tree");
  var contactNode = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  var email = contactNode.id;
  var nick = contactNode.getAttribute("nickname");
  if (window.client.isContactInList(email, "BL") == true) {
    var status = window.client.getContactStatus(email);
    window.client.removeContact(email, "BL");
    window.client.addContact(email, "AL");
    if (status == "NLN" || status == "FLN") {
      contactNode.setAttribute("label", " " + nick);
    }
    else {
      contactNode.setAttribute("label", " " + nick + " (" + window.client.bundle.GetStringFromName("StatusMsg" + status) + ")");
    }
    contactNode.setAttribute("src", StatusImages[status]);
  }
  else {
    window.client.removeContact(email, "AL");
    window.client.addContact(email, "BL");
    contactNode.setAttribute("label", " " + nick + " (" + window.client.bundle.GetStringFromName("StatusMsgBLK") + ")");
    contactNode.setAttribute("src", StatusImages["BLK"]);
  }
}

function viewProfile() {
  var tree = document.getElementById("contact-list-tree");
  var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  if (item.id != "emailItem" && item.id != "online" && item.id != "offline") {
    window.open("http://members.msn.com/default.msnw?mem=" + item.id, "_BLANK");
  }
}

function addContact(contactID, nickname, status, blocked) {
  var list = document.getElementById("offline-contacts-list");
  var shownStatus;
  blocked ? shownStatus = "BLK" : shownStatus = status;
  ti = createContactNode(contactID, nickname, shownStatus);
  list.appendChild(ti);
}

function addOfflineContact(contactID, blocked) {
  var contactNode = document.getElementById(contactID);
  var shownStatus;
  blocked ? shownStatus = "BLK" : shownStatus = "FLN";
  contactNode.setAttribute("src", StatusImages[shownStatus]);
  var movingContactNode = document.getElementById("online-contacts-list").removeChild(contactNode.parentNode.parentNode);
  document.getElementById("offline-contacts-list").appendChild(movingContactNode);
}

function addOnlineContact(contactID, nickname, status, blocked) {
  var contactNode = document.getElementById(contactID);
  var shownStatus;
  contactNode.setAttribute("nickname", nickname);
  blocked ? shownStatus = "BLK" : shownStatus = status;
  if (shownStatus == "NLN") {
    contactNode.setAttribute("label", " " + nickname);
  }
  else {
    contactNode.setAttribute("label", " " + nickname + " (" + window.client.bundle.GetStringFromName("StatusMsg" + shownStatus) + ")");
  }
  contactNode.setAttribute("src", StatusImages[shownStatus]);
  var movingContactNode = document.getElementById("offline-contacts-list").removeChild(contactNode.parentNode.parentNode);
  document.getElementById("online-contacts-list").appendChild(movingContactNode);
}

function contactNicknameChanged(contactID, nickname) {
  var contactNode = document.getElementById(contactID);
  var shownStatus;
  contactNode.setAttribute("nickname", nickname);
  if (window.client.isContactInList(contactID, "BL") == false) {
    shownStatus = window.client.getContactStatus(contactID);
  }
  else {
    shownStatus = "BLK";
  }
  if (shownStatus == "NLN") {
    contactNode.setAttribute("label", " " + nickname);
  }
  else {
    contactNode.setAttribute("label", " " + nickname + " (" + window.client.bundle.GetStringFromName("StatusMsg" + shownStatus) + ")");
  }
}

function contactStatusChanged(contactID, status, blocked) {
  var contactNode = document.getElementById(contactID);
  var shownStatus;
  blocked ? shownStatus = "BLK" : shownStatus = status;
  if (status != "NLN") {
    contactNode.setAttribute("label", " " + contactNode.getAttribute("nickname") + " (" + window.client.bundle.GetStringFromName("StatusMsg" + shownStatus) + ")");
  }
  else {
    contactNode.setAttribute("label", " " + contactNode.getAttribute("nickname"));
  }
  contactNode.setAttribute("src", StatusImages[shownStatus]);
}

function loginEmail(action, login, username, sid, kv, id, sl, rru, auth, creds) {
  var win = window.open("about:blank");
  var form = win.document.createElement("form");
  form.setAttribute("action", action);
  form.setAttribute("method", "POST");
  appendInput("login", login);
  appendInput("username", username);
  appendInput("sid", sid);
  appendInput("kv", kv);
  appendInput("id", id);
  appendInput("sl", sl);
  appendInput("rru", rru);
  appendInput("auth", auth);
  appendInput("creds", creds);
  appendInput("svc", "mail");
  appendInput("js", "yes");
  win.document.body.appendChild(form);
  form.submit();

  function appendInput(name, value) {
    var input = win.document.createElement("input");
    input.setAttribute("type", "hidden");
    input.setAttribute("name", name);
    input.setAttribute("value", value);
    form.appendChild(input);
  }
}

function loginFailed(label) {
  alert(window.client.bundle.GetStringFromName(label));
  signOut();
}

function loginProgress(progressValue, progressText) {
  document.getElementById("signin-progress").value = progressValue;
  document.getElementById("sign-in-status").textContent = window.client.bundle.GetStringFromName(progressText);
}

function loginSuccessful() {
  document.getElementById("main-pages").selectedIndex = 2;
}

function nicknameChanged(nickname) {
  document.getElementById("nickname").value = nickname;
}

function removeContact(email) {
  var contactNode = document.getElementById(email);
  var list = contactNode.parentNode.parentNode.parentNode;
  list.removeChild(contactNode.parentNode.parentNode);
}

function setupContactlist(contactlist) {
  for (var i in contactlist) {
    contact = contactlist[i];
    addContact(contact.email, contact.nickname, contact.status, this.client.isContactInList(contact.email, "BL"));
  }
}

function setupIncomingSession(contactID, host, port, cki, sessionID) {
  var win = window.client.getSessionWindow(contactID);
  if (win != null) {
    win.answerIncomingSession(contactID, host, port, cki, sessionID);
  }
  else {
    window.openDialog("chrome://msnmsgr/content/session.xul", "_blank", "chrome,resizable,dialog=no",
      {contactID: contactID, client: window.client},
      {host: host, port: port, cki: cki, sessionID: sessionID} );
  }
}

function setupSession() {
  var tree = document.getElementById("contact-list-tree");
  var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  var win = window.client.getSessionWindow(item.id);
  if (win == null) {
    window.openDialog("chrome://msnmsgr/content/session.xul", "_blank", "chrome,resizable,dialog=no",
      {contactID: item.id, client: window.client} );
  }
  else {
    win.focus();
  }
}

function showError(label) {
  alert(window.client.bundle.GetStringFromName(label));
}

function statusChanged(status) {
  var statusImg = document.getElementById("status-image");
  var statusDesc = document.getElementById("status-description");
  statusImg.src = StatusImages[status];
  statusDesc.value = window.client.bundle.GetStringFromName("YourStatusMsg" + status);
}

function updateEmailItem(emails) {
  switch (emails) {
    case 0:
      emails = window.client.bundle.GetStringFromName("noNewEmail");
      break;
    case 1:
      emails = window.client.bundle.GetStringFromName("oneNewEmail");
      break;
    default:
      emails = emails + " " +window.client.bundle.GetStringFromName("newEmail");
      break;
  }
  window.document.getElementById("emailItem").setAttribute("label", emails);
}

function createContactNode(email, nickname, status) {
    var ti = document.createElement("treeitem");
    var tr = document.createElement("treerow");
    var tc = document.createElement("treecell");
    var str = " " + nickname;
    if ((status != "NLN") && (status != "FLN")) {
        str += " (" + client.bundle.GetStringFromName("StatusMsg" + status) + ")";
    }
    tc.setAttribute("label", " " + str);
    tc.setAttribute("nickname", nickname);
    tc.setAttribute("id", email);
    tc.setAttribute("src", StatusImages[status]);
    tr.appendChild(tc);
    ti.appendChild(tr);
    return ti;
}